-- GLOBALS
KQ_allowWhispers = true
KQ_saveWhenreloading = false
KQ_whisperMessage = ""
KQ_whisperSender = ""
KQ_whisperClass = 0
KQ_HideSystemMSG = false

-- UIMAIN
local isUIMAINHidden = true
local isFirstRun = true
UIMAIN = CreateFrame("Frame", "KeystoneHelperMain", UIParent, "BasicFrameTemplateWithInset")
UIMAIN:Hide()
--UIMAIN:SetSize(300, 350); original
UIMAIN:SetSize(300, 380)
UIMAIN:SetPoint("CENTER", UIParent, "CENTER");
UIMAIN:SetMovable(true)
UIMAIN:EnableMouse(true)
UIMAIN:RegisterForDrag("LeftButton")
UIMAIN:SetScript("OnDragStart", UIMAIN.StartMoving)
UIMAIN:SetScript("OnDragStop", UIMAIN.StopMovingOrSizing)
UIMAIN:SetClampedToScreen(true)

local topBarString = UIMAIN:CreateFontString("$parrenttopbarstring", "ARTWORK", "GameFontNormal")
topBarString:SetText("KeyQueue")
topBarString:SetPoint("TOP", UIMAIN, "TOP", 0, -5)

-- TAB ONE

local UIFrameOne = CreateFrame("Frame", "KeystoneHelperFrame", UIMAIN);

local KeySlot = CreateFrame("Frame", "$parrentKeySlot", UIFrameOne);
KeySlot:SetSize(50,50);
KeySlot:SetPoint("TOP", UIMAIN, "TOPLEFT", 50, -40);

ufTexture = KeySlot:CreateTexture()
ufTexture:SetTexture("Interface\\AddOns\\KeyQueue\\img\\INV_Relics_Hourglass")
ufTexture:SetPoint("CENTER", UIMAIN)
ufTexture:SetSize(50,50)
ufTexture:SetAllPoints(KeySlot)


local backdrop = {
  -- path to the background texture
  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background",  
  -- true to repeat the background texture to fill the frame, false to scale it
  tile = false,
  -- size (width or height) of the square repeating background tiles (in pixels)
  tileSize = 50,
  -- thickness of edge segments and square size of edge corners (in pixels)
  edgeSize = 50,
  -- distance from the edges of the frame to those of the background texture (in pixels)
  insets = {
    left = 0,
    right = 0,
    top = 0,
    bottom = 0
  }
};
KeySlot:SetBackdrop(backdrop)
local tooltip = CreateFrame("GAMETOOLTIP", "$parrenttooltip", UIParent, "GameTooltipTemplate")
KeySlot:SetScript("OnEnter", function(self)
	--name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(137642)
	link = GetKey()
	tooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
	tooltip:SetHyperlink(link)
	tooltip:Show()
end)
KeySlot:SetScript("OnLeave", function(self)
	tooltip:Hide()
end)

local dungeonString = UIFrameOne:CreateFontString("$parrentdungeonString", "ARTWORK", "GameFontNormalLarge2")
local affixone = UIFrameOne:CreateFontString("$parrentaffixone", "ARTWORK", "GameFontNormal")
local affixtwo = UIFrameOne:CreateFontString("$parrentaffixtwo", "ARTWORK", "GameFontNormal")
local affixthree = UIFrameOne:CreateFontString("$parrentaffixthree", "ARTWORK", "GameFontNormal")

local editBox = CreateFrame("EditBox", "$parrentEditBrame", UIFrameOne, "InputBoxTemplate")
editBox:SetAutoFocus(false)
editBox:ClearFocus()
editBox:SetSize(200,50)
editBox:SetPoint("BOTTOM", UIMAIN, "BOTTOM", 0, 50)
editBox:SetMovable(true)

local editString = UIFrameOne:CreateFontString("$parrenteditboxfontstring", "ARTWORK", "GameFontNormal")
editString:SetText("Player server")
editString:SetPoint("LEFT", editBox, "TOPLEFT", 0, 0)

local editBox2 = CreateFrame("EditBox", "$parrentEditBrame", UIFrameOne, "InputBoxTemplate")
editBox2:SetAutoFocus(false)
editBox2:ClearFocus()
editBox2:SetSize(200,50)
editBox2:SetPoint("BOTTOM", editBox, "TOP", 0, 10)
editBox2:SetMovable(true)

local editString = UIFrameOne:CreateFontString("$parrenteditboxfontstring", "ARTWORK", "GameFontNormal")
editString:SetText("Player name")
editString:SetPoint("LEFT", editBox2, "TOPLEFT", 0, 0)


local submitButton = CreateFrame("Button", "$parrentsubmitbutton", UIFrameOne, "UIPanelButtonTemplate")
submitButton:SetSize(150,30) 
submitButton:SetPoint("BOTTOM", editBox, "BOTTOM", 0, -35)
submitButton:SetText("Submit Keystone")

function loadDungeonStrings()
	dungeonID, keystoneLevel, affixIDs, lootEligible = getMyKeystone()
	if dungeonID == nil then
		dungeonString:SetText("You have no keystone")
		dungeonString:SetPoint("LEFT", KeySlot, "TOPRIGHT", 5, -20)
		
		submitButton:Disable()
		
		
		
	else 
		submitButton:Enable()
		dungeonName = C_ChallengeMode.GetMapInfo(dungeonID)
		dungeonString:SetText(dungeonName .. " [+" .. keystoneLevel .. "]")
		dungeonString:SetPoint("LEFT", KeySlot, "TOPRIGHT", 5, -20)
		dungeonString:SetWidth(200)
		affixone:SetTextColor(1,1,1,0.9)
		affixtwo:SetTextColor(1,1,1,0.9)
		affixthree:SetTextColor(1,1,1,0.9)
		
	end
end

submitButton:SetScript("OnClick", function(self)
	player = editBox2:GetText()
	server = editBox:GetText()
	server = gsub(server, "%s", "")
	dungeonID, keystoneLevel, affixIDs, lootEligible = getMyKeystone()
	glme, glem, class = UnitClass("player")
	me, myServer = UnitFullName("player")
	me = me .. "-" .. myServer
	overall, equipped = GetAverageItemLevel()
	if server == "" then
		player = player
	else 
		player = player .. "-" .. server
	end
	SendAddonMessage("KeystoneHelper", format("keynameclass:%d:%d:%d:%s:%d:%d", dungeonID, keystoneLevel, lootEligible, me, class, overall), "WHISPER", player)
end)

-- TAB TWO

local UIFrameTwo = CreateFrame("Frame", "KeystoneHelperFrametwo", UIMAIN);

local info1 = UIFrameTwo:CreateFontString("$parrentinfo1", "ARTWORK", "GameFontNormal")
info1:SetPoint("TOPLEFT", UIMAIN, "TOPLEFT", 15, -38)
info1:SetText("List updates on whispers")
info1:SetTextColor(0.5, 0.5, 0.5, 0.5)

local info2 = UIFrameTwo:CreateFontString("$parrentinfo2", "ARTWORK", "GameFontNormal")
info2:SetPoint("TOPRIGHT", UIMAIN, "TOPRIGHT", -40, -38)
info2:SetText("Clear list")


local clearListButton = CreateFrame("Button", "$parrentsubmitbutton", UIFrameTwo, "UIPanelButtonTemplate")
clearListButton:SetSize(25,25) 
clearListButton:SetPoint("LEFT", info2, "RIGHT", 0, 0)



local applicantHeader = CreateFrame("Frame", "$parrentapplicantHeader", UIFrameTwo)
applicantHeader:SetSize(250,20)
applicantHeader:SetPoint("TOP", UIMAIN, "TOP", -10, -65)
local textureFrameHeader = applicantHeader:CreateTexture("ARTWORK")
textureFrameHeader:SetColorTexture(0.5, 0.5, 0.5, 0.2)
textureFrameHeader:SetAllPoints(applicantHeader)

local checkString = UIFrameTwo:CreateFontString("$parrentqueuecheck", "ARTWORK", "GameFontNormal")

checkString:SetPoint("CENTER", applicantHeader, "CENTER", -5, 0)

local applicantSlider = CreateFrame("Slider", "$parrentSlider", UIFrameTwo)
applicantSlider:SetPoint("TOPLEFT", applicantHeader, "TOPRIGHT", 5 ,5)
applicantSlider:SetHeight(310)
applicantSlider:SetWidth(17)
applicantSlider:SetOrientation("VERTICAL") 
applicantSlider:SetValue(0)
applicantSlider:SetMinMaxValues(0,1)
applicantSlider:SetBackdrop({
	bgFile = "Interface\\Buttons\\UI-SliderBar-Background", 
  edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
  tile = true, tileSize = 8, edgeSize = 8, 
  insets = { left = 3, right = 3, top = 6, bottom = 6 }})

applicantSlider:SetObeyStepOnDrag(true)
applicantSlider:SetValueStep(1)
applicantSlider:SetThumbTexture("Interface\\Buttons\\UI-ScrollBar-Knob")



applicantFrame = {}
applicantFrameTexture = {}

applicantFrame[0] = CreateFrame("Frame", "$parrentapplicant1", UIFrameTwo, "ApplicantTemplate")
applicantFrame[0]:SetPoint("TOP", applicantHeader, "BOTTOM", 0, 0)
applicantFrameTexture[0] = applicantFrame[0]:CreateTexture("ARTWORK")
applicantFrameTexture[0]:SetColorTexture(58/100, 48/100, 68/100, 0.1)
applicantFrameTexture[0]:SetAllPoints(applicantFrame[0])

 applicantFrame[1] = CreateFrame("Frame", "$parrentapplicant2", UIFrameTwo, "ApplicantTemplate")
applicantFrame[1]:SetPoint("TOP", applicantFrame[0], "BOTTOM", 0, -2)
 applicantFrameTexture[1] = applicantFrame[1]:CreateTexture("ARTWORK")
applicantFrameTexture[1]:SetColorTexture(48/100, 58/100, 68/100, 0.1)
applicantFrameTexture[1]:SetAllPoints(applicantFrame[1])

 applicantFrame[2] = CreateFrame("Frame", "$parrentapplicant3", UIFrameTwo, "ApplicantTemplate")
applicantFrame[2]:SetPoint("TOP", applicantFrame[1], "BOTTOM", 0 , -2)
 applicantFrameTexture[2] = applicantFrame[2]:CreateTexture("ARTWORK")
applicantFrameTexture[2]:SetColorTexture(48/100, 58/100, 68/100, 0.1)
applicantFrameTexture[2]:SetAllPoints(applicantFrame[2])

 applicantFrame[3] = CreateFrame("Frame", "$parrentapplicant1", UIFrameTwo, "ApplicantTemplate")
applicantFrame[3]:SetPoint("TOP", applicantFrame[2], "BOTTOM", 0, -2)
 applicantFrameTexture[3] = applicantFrame[3]:CreateTexture("ARTWORK")
applicantFrameTexture[3]:SetColorTexture(58/100, 48/100, 68/100, 0.1)
applicantFrameTexture[3]:SetAllPoints(applicantFrame[3])

 applicantFrame[4] = CreateFrame("Frame", "$parrentapplicant2", UIFrameTwo, "ApplicantTemplate")
applicantFrame[4]:SetPoint("TOP", applicantFrame[3], "BOTTOM", 0, -2)
 applicantFrameTexture[4] = applicantFrame[4]:CreateTexture("ARTWORK")
applicantFrameTexture[4]:SetColorTexture(48/100, 58/100, 68/100, 0.1)
applicantFrameTexture[4]:SetAllPoints(applicantFrame[4])

 applicantFrame[5] = CreateFrame("Frame", "$parrentapplicant3", UIFrameTwo, "ApplicantTemplate")
applicantFrame[5]:SetPoint("TOP", applicantFrame[4], "BOTTOM", 0, -2)
 applicantFrameTexture[5] = applicantFrame[5]:CreateTexture("ARTWORK")
applicantFrameTexture[5]:SetColorTexture(48/100, 58/100, 68/100, 0.1)
applicantFrameTexture[5]:SetAllPoints(applicantFrame[5])

 applicantFrame[6] = CreateFrame("Frame", "$parrentapplicant1", UIFrameTwo, "ApplicantTemplate")
applicantFrame[6]:SetPoint("TOP", applicantFrame[5], "BOTTOM", 0, -2)
 applicantFrameTexture[6] = applicantFrame[6]:CreateTexture("ARTWORK")
applicantFrameTexture[6]:SetColorTexture(58/100, 48/100, 68/100, 0.1)
applicantFrameTexture[6]:SetAllPoints(applicantFrame[6])

 applicantFrame[7] = CreateFrame("Frame", "$parrentapplicant2", UIFrameTwo, "ApplicantTemplate")
applicantFrame[7]:SetPoint("TOP", applicantFrame[6], "BOTTOM", 0, -2)
 applicantFrameTexture[7] = applicantFrame[7]:CreateTexture("ARTWORK")
applicantFrameTexture[7]:SetColorTexture(48/100, 58/100, 68/100, 0.1)
applicantFrameTexture[7]:SetAllPoints(applicantFrame[7])

 applicantFrame[8] = CreateFrame("Frame", "$parrentapplicant3", UIFrameTwo, "ApplicantTemplate")
applicantFrame[8]:SetPoint("TOP", applicantFrame[7], "BOTTOM", 0, -2)
 applicantFrameTexture[8] = applicantFrame[8]:CreateTexture("ARTWORK")
applicantFrameTexture[8]:SetColorTexture(48/100, 58/100, 68/100, 0.1)
applicantFrameTexture[8]:SetAllPoints(applicantFrame[8])

-- Applicant List LOGIC
applicants = {}
applicants[0] = {}


function KH_setClassTexture(applicantNumber, classNumber)

	classNumber = tonumber(classNumber)
	
	if classNumber == 0 then
		applicantFrameTexture[applicantNumber-1]:SetColorTexture(0,0,0,1)
	elseif classNumber == 1 then
		-- Warrior
		applicantFrameTexture[applicantNumber-1]:SetColorTexture(0.78, 0.61, 0.43, 0.3)
	elseif classNumber == 2 then
		-- Paladin
		applicantFrameTexture[applicantNumber-1]:SetColorTexture(0.96, 0.55, 0.73, 0.3)
	elseif classNumber == 3 then
		-- Hunter
		applicantFrameTexture[applicantNumber-1]:SetColorTexture(0.67, 0.83, 0.45, 0.3)
	elseif classNumber == 4 then
		-- Rogue
		applicantFrameTexture[applicantNumber-1]:SetColorTexture(1.00, 0.96, 0.41, 0.3)
	elseif classNumber == 5 then
		-- Priest
		applicantFrameTexture[applicantNumber-1]:SetColorTexture(1.00, 1.00, 1.00, 0.3)
	elseif classNumber == 6 then
		-- Death Knight
		applicantFrameTexture[applicantNumber-1]:SetColorTexture(0.77, 0.12, 0.23, 0.3)
	elseif classNumber == 7 then
		-- Shaman
		applicantFrameTexture[applicantNumber-1]:SetColorTexture(0.00, 0.44, 0.87, 0.3)
	elseif classNumber == 8 then
		-- Mage
		applicantFrameTexture[applicantNumber-1]:SetColorTexture(0.41, 0.80, 0.94, 0.3)
	elseif classNumber == 9 then
		-- Warlock
		applicantFrameTexture[applicantNumber-1]:SetColorTexture(0.58, 0.51, 0.79, 0.3)
	elseif classNumber == 10 then
		-- Monk 
		applicantFrameTexture[applicantNumber-1]:SetColorTexture(0.00, 1.00, 0.59, 0.3)
	elseif classNumber == 11 then
		-- Druid
		applicantFrameTexture[applicantNumber-1]:SetColorTexture(1.00, 0.49, 0.04, 0.3)
	else 
		print("Something went wrong")
	end
	
	applicantFrameTexture[applicantNumber-1]:SetAllPoints(applicantFrame[applicantNumber-1])

end

function KH_UpdateApplicants(startApplicant)
	local name = "ApplicantTemplateFontString"
	sliderMax = #applicants
	if sliderMax < 10 then
		--applicantSlider:Hide()
		applicantSlider:SetMinMaxValues(0,0)
	else
		--applicantSlider:Show()
		applicantSlider:SetMinMaxValues(0, sliderMax-9)
	end
	
	for i=1,9 do
		if applicants[startApplicant + i] ~= nil then 
			applicantFrame[i-1]:Show()
			local instance = applicants[startApplicant + (i)][0]
			local keyLevel = applicants[startApplicant + (i)][1]
			applicantFrame[i-1].TextStringKey:SetText("+" .. keyLevel)
			applicantFrame[i-1].TextStringDungeon:SetText(instance)
			if applicants[startApplicant + i][6] == 0 then
				applicantFrame[i-1].InviteButton:Enable()
				applicantFrame[i-1].InviteButton:SetText("Invite")
			else
				applicantFrame[i-1].InviteButton:Disable()
				applicantFrame[i-1].InviteButton:SetText("Invited")
			end
			if applicants[startApplicant + i][5] == 0 then
				applicantFrame[i-1].TextStringilvl:SetText("")
			else 
				applicantFrame[i-1].TextStringilvl:SetText(tostring(applicants[startApplicant+i][5]))
			end
			applicantFrame[i-1].InviteButton:SetScript("OnClick", function(self)
				applicantFrame[i-1].InviteButton:Disable()
				applicantFrame[i-1].InviteButton:SetText("Invited")
				applicants[startApplicant + i][6] = 1
				InviteUnit(applicants[startApplicant + i][3])
				print("Inviting: ", applicants[startApplicant + i][3])
				--[[table.remove(applicants, startApplicant + i)
				if startApplicant - 1 > 0 then
					KH_UpdateApplicants(startApplicant)
				else 
					KH_UpdateApplicants(0)
				end]]--
			end)
			KH_setClassTexture(i, applicants[startApplicant + i][4])
		else 
			applicantFrame[i-1]:Hide()
		end
	end
end

function addApplicant(dungeon, key, loot, name, class, ilvl)
	for x = 1, #applicants do
		if applicants[x][3] == name then
			return
		end
		
	end
	dungeon = C_ChallengeMode.GetMapInfo(dungeon)
	number = #applicants + 1 
	applicants[number] = {}
	applicants[number][0] = dungeon
	applicants[number][1] = key
	applicants[number][2] = loot
	applicants[number][3] = name
	applicants[number][4] = class
	applicants[number][5] = ilvl
	applicants[number][6] = 0
	
	KH_UpdateApplicants(applicantSlider:GetValue())
	
end

-- Extra slider logic

applicantSlider:SetScript("OnValueChanged", function(self, value)
	KH_UpdateApplicants(value)
end)

UIMAIN:SetScript("OnMouseWheel", function(self, delta)
	local current = applicantSlider:GetValue()
	
	if delta < 0 and current < #applicants-9 then
		applicantSlider:SetValue(current+1)
	elseif delta > 0 and current >= 1 then
		applicantSlider:SetValue(current - 1)
	end
end)

-- TAB LOGIC
UIFrameOne:Hide()
UIFrameTwo:Show()
KH_UpdateApplicants(0)
applicantSlider:SetValue(0)
if KQ_allowWhispers == false then
			checkString:SetText("Ignores whispers")
			checkString:SetTextColor(1,0,0,1)
		else
			checkString:SetText("Accepts whispers")
			checkString:SetTextColor(0,1,0,1)
		end
local isTabOne = false

local UITabOne = CreateFrame("Button", "$parrenttabone", UIMAIN, "TabButtonTemplate")
UITabOne:ClearAllPoints()
UITabOne:SetPoint("TOPLEFT", UIMAIN, "TOPLEFT", 0, 35)
UITabOne:SetText("My keystone")
PanelTemplates_TabResize(UITabOne)


local UITabTwo = CreateFrame("Button", "$parrenttabtwo", UIMAIN, "TabButtonTemplate")
UITabTwo:ClearAllPoints()
UITabTwo:SetPoint("LEFT", UITabOne, "RIGHT", 0, 0)
UITabTwo:SetText("Find keystone")
PanelTemplates_TabResize(UITabTwo)
UITabTwo:LockHighlight()
UITabOne:SetScript("OnClick", function(self)
	if isTabOne == false then
		isTabOne = true
		UITabTwo:UnlockHighlight()
		UITabOne:LockHighlight()
		UIFrameTwo:Hide()
		UIFrameOne:Show()
	end
end)
UITabTwo:SetScript("OnClick", function(self)
	if isTabOne == true then
		isTabOne = false
		UITabOne:UnlockHighlight()
		UITabTwo:LockHighlight()
		UIFrameOne:Hide()
		UIFrameTwo:Show()
		KH_UpdateApplicants(0)
		applicantSlider:SetValue(0)	
		if KQ_allowWhispers == false then
			checkString:SetText("Ignores whispers")
			checkString:SetTextColor(1,0,0,1)
		else
			checkString:SetText("Accepts whispers")
			checkString:SetTextColor(0,1,0,1)
		end
	end
end)

-- LOAD UI

UIMAIN:SetScript("OnShow", function(self)
	loadDungeonStrings()
	isUIMAINHidden = false
end)

UIMAIN:SetScript("OnHide", function(self)
	isUIMAINHidden = true
end)

-- SLASH COMMANDS
SLASH_KEYSTONEHELPER1, SLASH_KEYSTONEHELPER2 = "/keyqueue", "/kq";
function SlashCmdList.KEYSTONEHELPER(msg)
	if msg == "clear" then
		applicants = {}
		applicants[0] = {}
		KH_UpdateApplicants(0)
		return
	end
	if msg == "w" then
		if KQ_allowWhispers == true then
			checkString:SetText("Ignores whispers")
			checkString:SetTextColor(1,0,0,1)
			KQ_allowWhispers = false
		else
			checkString:SetText("Accepts whispers")
			checkString:SetTextColor(0,1,0,1)
			KQ_allowWhispers = true
		end
		return
	end
	if isUIMAINHidden then
		isUIMAINHidden = false
		UIMAIN:Show()
	else 
		isUIMAINHidden = true 
		UIMAIN:Hide()
	end
end

-- "" NETWORK "" 

local function converClassToNumber(class)
	classNum = 0
	if class == "Warrior" then
		classNum = 1
	end
	if class == "Paladin" then
		classNum = 2
	end
	if class == "Hunter" then
		classNum = 3
	end
	if class == "Rogue" then
		classNum = 4
	end
	if class == "Priest" then
		classNum = 5
	end
	if class == "Death Knight" then
		classNum = 6
	end
	if class == "Shaman" then
		classNum = 7
	end
	if class == "Mage" then
		classNum = 8
	end
	if class == "Warlock" then
		classNum = 9
	end
	if class == "Monk" then
		classNum = 10
	end
	if class == "Druid" then
		classNum = 11
	end
	return classNum
end

function handleWhisper()
	originalLinkSubstring = strsub(KQ_whisperMessage, 11, strfind(KQ_whisperMessage, '|h') - 1)
	parts = { strsplit(':', originalLinkSubstring) }
	local length = #parts
	
	if tonumber(parts[2]) == 138019 then
		dungeonID = tonumber(parts[15])
		keystoneLevel = tonumber(parts[16])
		--KQ_HideSystemMSG = true
		--SendWho(KQ_whisperSender)
		--name, guild, level, race, class, zone, classFileName, sex = GetWhoInfo(1)
		--class = converClassToNumber(class)
		addApplicant(dungeonID, keystoneLevel, 0, KQ_whisperSender, 0, 0)
	end
end

function handleWhisperBN()
	originalLinkSubstring = strsub(KQ_whisperMessage, 11, strfind(KQ_whisperMessage, '|h') - 1)
	parts = { strsplit(':', originalLinkSubstring) }
	
	local length = #parts
	
	
	if tonumber(parts[1]) == 8019 then
		dungeonID = tonumber(parts[14])
		keystoneLevel = tonumber(parts[15])
		--KQ_HideSystemMSG = true
		--SendWho(KQ_whisperSender)
		--name, guild, level, race, class, zone, classFileName, sex = GetWhoInfo(1)
		addApplicant(dungeonID, keystoneLevel, 0, KQ_whisperSender, KQ_whisperClass, 0)
	end
end

local function eventHandler(self, event, prefix, msg, channel, sender, presenceID)
	KQ_whisperClass = 0
	if event == 'CHAT_MSG_ADDON' and prefix == 'KeystoneHelper' then
		-- Another user's keystone info (which we may or may not have asked for, but print either way)
		prefix = 'keynameclass:'
		if strsub(msg, 1, strlen(prefix)) == prefix then
			_, dungeonID, keystoneLevel, lootEligible, name, class, ilvl = strsplit(':', msg)	
			addApplicant(dungeonID, keystoneLevel, lootEligible, name, class, ilvl)
		end
	end
	if event == 'CHAT_MSG_WHISPER' and KQ_allowWhispers == true then
		KQ_whisperSender = msg
		KQ_whisperMessage = prefix
		--originalLinkSubstring = strsub(msg, 11, strfind(msg, '|h') - 1)
		
		if pcall(handleWhisper) then
			--print("Success")
		else
			--print("Failure")
		end
	end
	if event == 'CHAT_MSG_BN_WHISPER' and KQ_allowWhispers == true then
		KQ_whisperSender = msg
		KQ_whisperMessage = prefix
		
		local _, numFreinds = BNGetNumFriends()
				
		for index = 1, numFreinds do
			local name = select(2, BNGetFriendInfo(index))
			if KQ_whisperSender == name then
				local bnetIDGameAccount, client = select(6, BNGetFriendInfo(index))
				client = select(7, BNGetFriendInfo(index))
				if client == "WoW" then
					local _, characterName, _, realmName, _, faction, _, class = BNGetGameAccountInfo(bnetIDGameAccount)
					local factionGroup, factionName = UnitFactionGroup("player")
					if faction == factionGroup then
						KQ_whisperClass = converClassToNumber(class)
						KQ_whisperSender = characterName.."-"..realmName
						if pcall(handleWhisperBN) then
							--print("Success")
						else
							--print("Failure")
						end
					end
				end
			end
		end
	end
	if event == 'CHAT_MSG_SYSTEM' then
		prefix = tostring(prefix)
		find1 = string.find(prefix, "joins the party.")
		find2 = string.find(prefix, "declines your group invitation.")
		if find1 ~= nil then
			parts = { strsplit(' ', prefix) }
			lenght = #applicants
			for index = 1, lenght do
				if parts[1] == applicants[index][3] then
					table.remove(applicants, index)
					if startApplicant - 1 > 0 then
						KH_UpdateApplicants(startApplicant)
					else 
						KH_UpdateApplicants(0)
					end
				end
			end
		elseif find2 ~= nil then
			parts = { strsplit(' ', prefix) }
			lenght = #applicants
			for index = 1, lenght do
				if parts[1] == applicants[index][3] then
					table.remove(applicants, index)
					if startApplicant - 1 > 0 then
						KH_UpdateApplicants(startApplicant)
					else 
						KH_UpdateApplicants(0)
					end
				end
			end
		end	
	end
	if event == "ADDON_LOADED" then
		KH_UpdateApplicants(0)
	end
end

UIMAIN:RegisterEvent('CHAT_MSG_ADDON')
UIMAIN:RegisterEvent('CHAT_MSG_WHISPER')
UIMAIN:RegisterEvent('CHAT_MSG_BN_WHISPER')
UIMAIN:SetScript('OnEvent', eventHandler)
RegisterAddonMessagePrefix('KeystoneHelper')
UIMAIN:RegisterEvent('CHAT_MSG_SYSTEM')

clearListButton:SetScript("OnClick", function(self)
	applicants = {}
	applicants[0] = {}
	KH_UpdateApplicants(0)
end)

function printApplicants()
	for x=1, #applicants do
		print(applicants[x][3])
	end
end



function test()
	local _, numFreinds = BNGetNumFriends()
		
	for index = 1, numFreinds do
		local bnetIDGameAccount, client = select(6, BNGetFriendInfo(index))
		client = select(7, BNGetFriendInfo(index))
		print(client)
		name = select(2, BNGetFriendInfo(index))
		print(name)	
		if client == "WoW" then
			local _, characterName, _, realmName, _, faction, _, class = BNGetGameAccountInfo(bnetIDGameAccount)
			print(characterName .." ".. realmName .. " " .. class.. " ".. faction)
		end
	end
end

-- Saved variables



UIMAIN:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
UIMAIN:RegisterEvent("PLAYER_LOGOUT"); -- Fired when about to log out

--PRINT TO USER
print("/kq - to open KeyQueue")
